package sun.misc;

import java.security.ProtectionDomain;
import java.lang.reflect.Modifier;
import java.lang.reflect.Field;
import sun.reflect.CallerSensitive;
import sun.reflect.Reflection;

public final class Unsafe
{
    private static final Unsafe theUnsafe;
    public static final int INVALID_FIELD_OFFSET = -1;
    public static final int ARRAY_BOOLEAN_BASE_OFFSET;
    public static final int ARRAY_BYTE_BASE_OFFSET;
    public static final int ARRAY_SHORT_BASE_OFFSET;
    public static final int ARRAY_CHAR_BASE_OFFSET;
    public static final int ARRAY_INT_BASE_OFFSET;
    public static final int ARRAY_LONG_BASE_OFFSET;
    public static final int ARRAY_FLOAT_BASE_OFFSET;
    public static final int ARRAY_DOUBLE_BASE_OFFSET;
    public static final int ARRAY_OBJECT_BASE_OFFSET;
    public static final int ARRAY_BOOLEAN_INDEX_SCALE;
    public static final int ARRAY_BYTE_INDEX_SCALE;
    public static final int ARRAY_SHORT_INDEX_SCALE;
    public static final int ARRAY_CHAR_INDEX_SCALE;
    public static final int ARRAY_INT_INDEX_SCALE;
    public static final int ARRAY_LONG_INDEX_SCALE;
    public static final int ARRAY_FLOAT_INDEX_SCALE;
    public static final int ARRAY_DOUBLE_INDEX_SCALE;
    public static final int ARRAY_OBJECT_INDEX_SCALE;
    public static final int ADDRESS_SIZE;
    
    private static native void registerNatives();
    
    private Unsafe() {
    }
    
    @CallerSensitive
    public static Unsafe getUnsafe() {
        if (!VM.isSystemDomainLoader(Reflection.getCallerClass().getClassLoader())) {
            throw new SecurityException("Unsafe");
        }
        return Unsafe.theUnsafe;
    }
    
    public native int getInt(Object p0, long p1);
    
    public native void putInt(Object p0, long p1, int p2);
    
    public native Object getObject(Object p0, long p1);
    
    public native void putObject(Object p0, long p1, Object p2);
    
    public native boolean getBoolean(Object p0, long p1);
    
    public native void putBoolean(Object p0, long p1, boolean p2);
    
    public native byte getByte(Object p0, long p1);
    
    public native void putByte(Object p0, long p1, byte p2);
    
    public native short getShort(Object p0, long p1);
    
    public native void putShort(Object p0, long p1, short p2);
    
    public native char getChar(Object p0, long p1);
    
    public native void putChar(Object p0, long p1, char p2);
    
    public native long getLong(Object p0, long p1);
    
    public native void putLong(Object p0, long p1, long p2);
    
    public native float getFloat(Object p0, long p1);
    
    public native void putFloat(Object p0, long p1, float p2);
    
    public native double getDouble(Object p0, long p1);
    
    public native void putDouble(Object p0, long p1, double p2);
    
    @Deprecated
    public int getInt(Object o, int n) {
        return this.getInt(o, (long)n);
    }
    
    @Deprecated
    public void putInt(Object o, int n, int n2) {
        this.putInt(o, (long)n, n2);
    }
    
    @Deprecated
    public Object getObject(Object o, int n) {
        return this.getObject(o, (long)n);
    }
    
    @Deprecated
    public void putObject(Object o, int n, Object o2) {
        this.putObject(o, (long)n, o2);
    }
    
    @Deprecated
    public boolean getBoolean(Object o, int n) {
        return this.getBoolean(o, (long)n);
    }
    
    @Deprecated
    public void putBoolean(Object o, int n, boolean b) {
        this.putBoolean(o, (long)n, b);
    }
    
    @Deprecated
    public byte getByte(Object o, int n) {
        return this.getByte(o, (long)n);
    }
    
    @Deprecated
    public void putByte(Object o, int n, byte b) {
        this.putByte(o, (long)n, b);
    }
    
    @Deprecated
    public short getShort(Object o, int n) {
        return this.getShort(o, (long)n);
    }
    
    @Deprecated
    public void putShort(Object o, int n, short n2) {
        this.putShort(o, (long)n, n2);
    }
    
    @Deprecated
    public char getChar(Object o, int n) {
        return this.getChar(o, (long)n);
    }
    
    @Deprecated
    public void putChar(Object o, int n, char c) {
        this.putChar(o, (long)n, c);
    }
    
    @Deprecated
    public long getLong(Object o, int n) {
        return this.getLong(o, (long)n);
    }
    
    @Deprecated
    public void putLong(Object o, int n, long n2) {
        this.putLong(o, (long)n, n2);
    }
    
    @Deprecated
    public float getFloat(Object o, int n) {
        return this.getFloat(o, (long)n);
    }
    
    @Deprecated
    public void putFloat(Object o, int n, float n2) {
        this.putFloat(o, (long)n, n2);
    }
    
    @Deprecated
    public double getDouble(Object o, int n) {
        return this.getDouble(o, (long)n);
    }
    
    @Deprecated
    public void putDouble(Object o, int n, double n2) {
        this.putDouble(o, (long)n, n2);
    }
    
    public native byte getByte(long p0);
    
    public native void putByte(long p0, byte p1);
    
    public native short getShort(long p0);
    
    public native void putShort(long p0, short p1);
    
    public native char getChar(long p0);
    
    public native void putChar(long p0, char p1);
    
    public native int getInt(long p0);
    
    public native void putInt(long p0, int p1);
    
    public native long getLong(long p0);
    
    public native void putLong(long p0, long p1);
    
    public native float getFloat(long p0);
    
    public native void putFloat(long p0, float p1);
    
    public native double getDouble(long p0);
    
    public native void putDouble(long p0, double p1);
    
    public native long getAddress(long p0);
    
    public native void putAddress(long p0, long p1);
    
    public native long allocateMemory(long p0);
    
    public native long reallocateMemory(long p0, long p1);
    
    public native void setMemory(Object p0, long p1, long p2, byte p3);
    
    public void setMemory(long n, long n2, byte b) {
        this.setMemory(null, n, n2, b);
    }
    
    public native void copyMemory(Object p0, long p1, Object p2, long p3, long p4);
    
    public void copyMemory(long n, long n2, long n3) {
        this.copyMemory(null, n, null, n2, n3);
    }
    
    public native void freeMemory(long p0);
    
    @Deprecated
    public int fieldOffset(Field field) {
        if (Modifier.isStatic(field.getModifiers())) {
            return (int)this.staticFieldOffset(field);
        }
        return (int)this.objectFieldOffset(field);
    }
    
    @Deprecated
    public Object staticFieldBase(Class<?> clazz) {
        Field[] declaredFields = clazz.getDeclaredFields();
        int i = 0;
        while (i < declaredFields.length) {
            if (Modifier.isStatic(declaredFields[i].getModifiers())) {
                return this.staticFieldBase(declaredFields[i]);
            }
            ++i;
        }
        return null;
    }
    
    public native long staticFieldOffset(Field p0);
    
    public native long objectFieldOffset(Field p0);
    
    public native Object staticFieldBase(Field p0);
    
    public native boolean shouldBeInitialized(Class<?> p0);
    
    public native void ensureClassInitialized(Class<?> p0);
    
    public native int arrayBaseOffset(Class<?> p0);
    
    public native int arrayIndexScale(Class<?> p0);
    
    public native int addressSize();
    
    public native int pageSize();
    
    public native Class<?> defineClass(String p0, byte[] p1, int p2, int p3, ClassLoader p4, ProtectionDomain p5);
    
    public native Class<?> defineAnonymousClass(Class<?> p0, byte[] p1, Object[] p2);
    
    public native Object allocateInstance(Class<?> p0) throws InstantiationException;
    
    @Deprecated
    public native void monitorEnter(Object p0);
    
    @Deprecated
    public native void monitorExit(Object p0);
    
    @Deprecated
    public native boolean tryMonitorEnter(Object p0);
    
    public native void throwException(Throwable p0);
    
    public final native boolean compareAndSwapObject(Object p0, long p1, Object p2, Object p3);
    
    public final native boolean compareAndSwapInt(Object p0, long p1, int p2, int p3);
    
    public final native boolean compareAndSwapLong(Object p0, long p1, long p2, long p3);
    
    public native Object getObjectVolatile(Object p0, long p1);
    
    public native void putObjectVolatile(Object p0, long p1, Object p2);
    
    public native int getIntVolatile(Object p0, long p1);
    
    public native void putIntVolatile(Object p0, long p1, int p2);
    
    public native boolean getBooleanVolatile(Object p0, long p1);
    
    public native void putBooleanVolatile(Object p0, long p1, boolean p2);
    
    public native byte getByteVolatile(Object p0, long p1);
    
    public native void putByteVolatile(Object p0, long p1, byte p2);
    
    public native short getShortVolatile(Object p0, long p1);
    
    public native void putShortVolatile(Object p0, long p1, short p2);
    
    public native char getCharVolatile(Object p0, long p1);
    
    public native void putCharVolatile(Object p0, long p1, char p2);
    
    public native long getLongVolatile(Object p0, long p1);
    
    public native void putLongVolatile(Object p0, long p1, long p2);
    
    public native float getFloatVolatile(Object p0, long p1);
    
    public native void putFloatVolatile(Object p0, long p1, float p2);
    
    public native double getDoubleVolatile(Object p0, long p1);
    
    public native void putDoubleVolatile(Object p0, long p1, double p2);
    
    public native void putOrderedObject(Object p0, long p1, Object p2);
    
    public native void putOrderedInt(Object p0, long p1, int p2);
    
    public native void putOrderedLong(Object p0, long p1, long p2);
    
    public native void unpark(Object p0);
    
    public native void park(boolean p0, long p1);
    
    public native int getLoadAverage(double[] p0, int p1);
    
    public final int getAndAddInt(Object o, long n, int n2) {
        int intVolatile;
        do {
            intVolatile = this.getIntVolatile(o, n);
        } while (!this.compareAndSwapInt(o, n, intVolatile, intVolatile + n2));
        return intVolatile;
    }
    
    public final long getAndAddLong(Object o, long n, long n2) {
        long longVolatile;
        do {
            longVolatile = this.getLongVolatile(o, n);
        } while (!this.compareAndSwapLong(o, n, longVolatile, longVolatile + n2));
        return longVolatile;
    }
    
    public final int getAndSetInt(Object o, long n, int n2) {
        int intVolatile;
        do {
            intVolatile = this.getIntVolatile(o, n);
        } while (!this.compareAndSwapInt(o, n, intVolatile, n2));
        return intVolatile;
    }
    
    public final long getAndSetLong(Object o, long n, long n2) {
        long longVolatile;
        do {
            longVolatile = this.getLongVolatile(o, n);
        } while (!this.compareAndSwapLong(o, n, longVolatile, n2));
        return longVolatile;
    }
    
    public final Object getAndSetObject(Object o, long n, Object o2) {
        Object objectVolatile;
        do {
            objectVolatile = this.getObjectVolatile(o, n);
        } while (!this.compareAndSwapObject(o, n, objectVolatile, o2));
        return objectVolatile;
    }
    
    public native void loadFence();
    
    public native void storeFence();
    
    public native void fullFence();
    
    private static void throwIllegalAccessError() {
        throw new IllegalAccessError();
    }
    
    static {
        registerNatives();
        Reflection.registerMethodsToFilter(Unsafe.class, new String[] { "getUnsafe" });
        theUnsafe = new Unsafe();
        ARRAY_BOOLEAN_BASE_OFFSET = Unsafe.theUnsafe.arrayBaseOffset(boolean[].class);
        ARRAY_BYTE_BASE_OFFSET = Unsafe.theUnsafe.arrayBaseOffset(byte[].class);
        ARRAY_SHORT_BASE_OFFSET = Unsafe.theUnsafe.arrayBaseOffset(short[].class);
        ARRAY_CHAR_BASE_OFFSET = Unsafe.theUnsafe.arrayBaseOffset(char[].class);
        ARRAY_INT_BASE_OFFSET = Unsafe.theUnsafe.arrayBaseOffset(int[].class);
        ARRAY_LONG_BASE_OFFSET = Unsafe.theUnsafe.arrayBaseOffset(long[].class);
        ARRAY_FLOAT_BASE_OFFSET = Unsafe.theUnsafe.arrayBaseOffset(float[].class);
        ARRAY_DOUBLE_BASE_OFFSET = Unsafe.theUnsafe.arrayBaseOffset(double[].class);
        ARRAY_OBJECT_BASE_OFFSET = Unsafe.theUnsafe.arrayBaseOffset(Object[].class);
        ARRAY_BOOLEAN_INDEX_SCALE = Unsafe.theUnsafe.arrayIndexScale(boolean[].class);
        ARRAY_BYTE_INDEX_SCALE = Unsafe.theUnsafe.arrayIndexScale(byte[].class);
        ARRAY_SHORT_INDEX_SCALE = Unsafe.theUnsafe.arrayIndexScale(short[].class);
        ARRAY_CHAR_INDEX_SCALE = Unsafe.theUnsafe.arrayIndexScale(char[].class);
        ARRAY_INT_INDEX_SCALE = Unsafe.theUnsafe.arrayIndexScale(int[].class);
        ARRAY_LONG_INDEX_SCALE = Unsafe.theUnsafe.arrayIndexScale(long[].class);
        ARRAY_FLOAT_INDEX_SCALE = Unsafe.theUnsafe.arrayIndexScale(float[].class);
        ARRAY_DOUBLE_INDEX_SCALE = Unsafe.theUnsafe.arrayIndexScale(double[].class);
        ARRAY_OBJECT_INDEX_SCALE = Unsafe.theUnsafe.arrayIndexScale(Object[].class);
        ADDRESS_SIZE = Unsafe.theUnsafe.addressSize();
    }
}
